# SoPickStyle Class Reference
[Nodes]

`#include <Inventor/nodes/SoPickStyle.h>`

Inheritance diagram for SoPickStyle:

List of all members.

## Detailed Description

The SoPickStyle class is a node for setting up how to do picking.

By default, all geometry in a scene is available for picking. Upon writing applications with interaction possibilities, this is often not what you want. To exclude parts of the scene graph from pick actions, use the SoPickStyle::UNPICKABLE.

You can also optimize pick operations by using the SoPickStyle::BOUNDING_BOX pickstyle.

See also:
  SoRayPickAction

## Public Types

enum | Style { SHAPE = SoPickStyleElement::SHAPE, BOUNDING_BOX = SoPickStyleElement::BOUNDING_BOX, UNPICKABLE = SoPickStyleElement::UNPICKABLE }

## Public Member Functions

| SoPickStyle (void)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | pick (SoPickAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFEnum | style

## Protected Member Functions

virtual | ~SoPickStyle ()

## Member Enumeration Documentation

enum SoPickStyle::Style

Enumeration of the available picking strategies.

Enumeration values:

  SHAPE | Do "exact" picks, finding the correct intersection point(s), etc.
  BOUNDING_BOX | Only compare pick intersection with the bounding boxes of shapes. This is usually much faster than SoPickStyle::SHAPE.
  UNPICKABLE | The geometry following this node in the scene will not be available for picking.

## Constructor & Destructor Documentation

SoPickStyle::SoPickStyle | ( | void |  | ) |

| Constructor.

SoPickStyle::~SoPickStyle | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoPickStyle::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoPickStyle::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoPickStyle::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoPickStyle::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

## Member Data Documentation

SoSFEnum SoPickStyle::style

| Which strategy to use for the picking actions for subsequent shapes in the scene graph. Default value is SoPickStyle::SHAPE.

The documentation for this class was generated from the following files:

- SoPickStyle.h
- SoPickStyle.cpp